<template>
    <HcCard>
        <template #header>
            <div class="w-36">
                <el-select v-model="searchForm.userIdVesting" block clearable placeholder="归属人" size="large">
                    <el-option label="暂无接口1" value="1"/>
                    <el-option label="暂无接口2" value="2"/>
                </el-select>
            </div>
            <div class="w-72 ml-2">
                <el-select v-model="searchForm.projectId" block clearable placeholder="项目名称" size="large">
                    <el-option v-for="item in projectType" :label="item.projectName" :value="item.projectId"/>
                </el-select>
            </div>
            <div class="ml-4">
                <el-button type="primary" @click="searchClick" size="large">
                    <HcIcon name="search-2"/>
                    <span>搜索</span>
                </el-button>
            </div>
            <div class="ml-2">
                <el-button size="large" @click="resetClick">
                    <HcIcon name="close-circle"/>
                    <span>重置</span>
                </el-button>
            </div>
        </template>
        <template #extra>
            <el-button size="large" type="warning" hc-btn @click="draftsClick">
                <HcIcon name="draft"/>
                <span>草稿箱{{draftNum > 0 ? `(${draftNum})` : ''}}</span>
            </el-button>
            <el-button size="large" type="primary" hc-btn @click="addRowClick">
                <HcIcon name="add"/>
                <span>新增报销记录</span>
            </el-button>
        </template>

        <HcTable :isIndex="false" :column="tableColumn" :datas="tableData" :loading="tableLoading">
            <template #frNumber="{row}">
                <span class="text-blue text-hover" @click="rowNameTap(row)">{{row.frNumber}}</span>
            </template>
            <template #action="{row,index}">
                <el-popconfirm title="是否确认撤销?" hide-icon @confirm="rowCancel(row)">
                    <template #reference>
                        <el-button size="small" type="primary"
                                   :disabled="row.status !== 1"
                                   :loading="row.isCancelLoading"
                        >撤销</el-button>
                    </template>
                </el-popconfirm>
            </template>
        </HcTable>

        <template #action>
            <HcPages :pages="searchForm" @change="pageChange"/>
        </template>

        <!--草稿箱-->
        <HcDialog isToBody isTable bgColor="#ffffff" widths="62rem" :footer="false" :show="draftsModal"
                  :title="draftNum > 0 ? `草稿箱(${draftNum})` : '草稿箱'" @close="draftsCloseClick"
        >
            <el-alert title="3个月内未更新的草稿将被自动删除" type="warning" show-icon />
            <div style="position: relative;height: calc(100% - 44px);">
                <HcTable :isIndex="false" :column="tableDraftsColumn" :datas="tableDraftsData">
                    <template #action="{row,index}">
                        <el-button size="small" type="primary" @click="editDraftClick(row)">继续编辑</el-button>
                        <el-button size="small" type="danger" @click="delDraftClick(row)">删除</el-button>
                    </template>
                </HcTable>
            </div>
        </HcDialog>
    </HcCard>
</template>

<script setup>
import {onActivated, ref} from "vue";
import {useRouter} from 'vue-router'
import mainApi from "~api/expense/finReimburse";
import {getProjectList} from "~api/other";
import {getArrValue} from "js-fast-way";
import {delMessage} from "~uti/tools";

const router = useRouter()

onActivated(() => {
    getApi()
})

const getApi = () => {
    getProjectData()
    getTableData()
    getDraftNum()
}


//项目类型
const projectType = ref([])
const getProjectData = async () => {
    const {error, code, data} = await getProjectList()
    //判断状态
    if (!error && code === 200) {
        projectType.value = getArrValue(data)
    } else {
        projectType.value = []
    }
}

//搜索表单
const searchForm = ref({userIdVesting: null, projectId: null, current: 1, size: 20, total: 0})

//搜索
const searchClick = () => {
    searchForm.value.current = 1;
    getTableData()
}

//重置搜索表单
const resetClick = () => {
    searchForm.value = {current: 1, size: 20, total: 0}
}

//分页被点击
const pageChange = ({current, size}) => {
    searchForm.value.current = current
    searchForm.value.size = size
    getTableData()
}

//获取数据
const tableLoading = ref(false)
const tableColumn = [
    {key: 'frNumber', name: '报销编号', width: '120', align: 'center'},
    {key: 'frType', name: '报销类型', width: '140'},
    {key: 'projectName', name: '项目名称', minWidth: '200'},
    {key: 'frMoney', name: '报销金额', width: '160', align: 'center'},
    {key: 'userNameVesting', name: '归属人', width: '140', align: 'center'},
    {key: 'approvalResultName', name: '审批结果', width: '140', align: 'center'},
    {key: 'approvalStatusName', name: '审批状态', width: '140', align: 'center'},
    {key: 'frDate', name: '报销时间', width: '160', align: 'center'},
    {key: 'createName', name: '创建人', width: '140', align: 'center'},
    {key: 'createTime', name: '创建时间', width: '180', align: 'center'},
    {key: 'action', name: '操作', width: '90', align: 'center', fixed: 'right'},
]
const tableData = ref([])
const getTableData = async () => {
    tableLoading.value = true
    const {error, code, data} = await mainApi.page(searchForm.value)
    //判断状态
    tableLoading.value = false
    if (!error && code === 200) {
        tableData.value = getArrValue(data['records'])
        searchForm.value.total = data['total'] || 0
    } else {
        tableData.value = []
        searchForm.value.total = 0
    }
}

//预览
const rowNameTap = ({id}) => {
    window.$message?.error('未知功能')
}

//撤销
const rowCancel = async (row) => {
    row.isCancelLoading = true
    const {error, code, msg} = await mainApi.cancel({
        id: row.id
    })
    //判断状态
    row.isCancelLoading = false
    if (!error && code === 200) {
        window.$message?.success(msg)
        getTableData().then()
    } else {
        window.$message?.error(msg)
    }
}

//新增预算
const addRowClick = () => {
    router.push({
        name: 'expense-finReimburse-record',
        query: {type: 'add'}
    })
}

//草稿箱
const draftsModal = ref(false)
const draftsClick = () => {
    tableDraftsData.value = []
    draftsModal.value = true
    getDraftNum()
}
const draftsCloseClick = () => {
    draftsModal.value = false
}

//草稿箱数据
const draftNum = ref(0)
const tableDraftsColumn = [
    {key: 'title', name: '标题'},
    {key: 'updateTime', name: '更新时间', width: '200'},
    {key: 'action', name: '操作', width: '170', align: 'center'},
]
const tableDraftsData = ref([])

//获取草稿数量
const getDraftNum = async () => {
    const {error, code, data} = await mainApi.draft()
    //判断状态
    if (!error && code === 200) {
        const res = getArrValue(data)
        tableDraftsData.value = res
        draftNum.value = res.length
    } else {
        tableDraftsData.value = []
        draftNum.value = 0
    }
}

//继续编辑
const editDraftClick = ({emdraftIds}) => {
    draftsModal.value = false
    router.push({
        name: 'expense-finReimburse-record',
        query: {id: emdraftIds, type: 'draft'}
    })
}

//删除草稿
const delDraftClick = ({groupId}) => {
    delMessage(async () => {
        const {error, code, msg} = await mainApi.remove({
            groupId: groupId
        })
        //判断状态
        if (!error && code === 200) {
            window.$message?.success(msg)
            getDraftNum().then()
        } else {
            window.$message?.error(msg)
        }
    })
}
</script>
